SystemOrganization addCategory: #'PDS-Singleton'!

Object subclass: #Singleton
	instanceVariableNames: 'data'
	classVariableNames: 'uniqueInstance'
	poolDictionaries: ''
	category: 'PDS-Singleton'!

!Singleton commentStamp: 'MatteoST 12/1/2014 20:57' prior: 0!
A Singleton class is a class that develop the Singleton pattern.
!

Singleton subclass: #SingleSon
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PDS-Singleton'!

!SingleSon commentStamp: 'sonmi 12/3/2014 11:55' prior: 0!
A SingleSon is aSingleton.

Instance Variables
	value:		generic basic value to store

value
	- number or letter


Test code for this class: 

| single tangle iniziale|
iniziale := Singleton current.
single := SingleSon current.
single value:740.
tangle := Singleton current.
tangle == single.
"the two instances referes to the same object, even if the frst instantiastion is a Singleton, and not a SingleSon isntance"!

!SingleSon methodsFor: 'accessing' stamp: 'sonmi 12/3/2014 11:50'!
value
	"Returns the value instance"

	^value.! !

!SingleSon methodsFor: 'accessing' stamp: 'sonmi 12/3/2014 11:50'!
value:anInteger
	"Store an integer in the variable value"

	value := anInteger.
	^self.! !

!Singleton class methodsFor: 'as yet unclassified' stamp: 'MatteoST 12/2/2014 18:58'!
current
	"retunr the unique instance of the singleton"

	uniqueInstance isNil ifTrue: [ uniqueInstance := self basicNew ].
	"Transcript show: 'Step01';cr."
	^uniqueInstance.! !

!Singleton class methodsFor: 'as yet unclassified' stamp: 'MatteoST 12/1/2014 21:01'!
new
	"forbids the use of the message new"

	
	^self error: 'This is a singleton class, please do not try to instantiate it'.! !

!Singleton methodsFor: 'as yet unclassified' stamp: 'MatteoST 12/2/2014 19:00'!
data
	"returns the value stored in data"


	^data! !

!Singleton methodsFor: 'as yet unclassified' stamp: 'MatteoST 12/2/2014 19:01'!
data: anInteger
	"Stores a integer in data"

	data := anInteger.
	^self.! !
